﻿namespace Singleton
{
    internal class Program
    {
        class Log //singleton
        {
            #region Singleton
            private static Log? instancja = null;

            public static Log Instancja
            {
                get
                {
                    if (instancja == null) instancja = new Log(); //leniwa inicjacja
                    return instancja;
                }
            }

            private Log()
            {
                Console.WriteLine("Rejestr zdarzeń został utworzony");
            }
            #endregion

            #region Rejestr zdarzeń
            private List<string> komunikaty = new List<string>();

            public void Dodaj(string komunikat)
            {
                komunikaty.Add(DateTime.Now.ToString() + " - " + komunikat);
            }

            private const string nazwaPliku = "log.txt";

            public void Zapisz()
            {
                try
                {
                    //powinno być Apend
                    File.WriteAllLines(nazwaPliku, komunikaty);
                }
                catch(Exception exc)
                {
                    throw new Exception("Błąd podczas zapisu pliku", exc);
                }
            }
            #endregion
        }

        static void Main(string[] args)
        {
            Log.Instancja.Dodaj("Uruchomienie aplikacji");

            new DalekaIGłębokaKlasa().Metoda();

            Log.Instancja.Dodaj("Zamykanie aplikacji");
            Log.Instancja.Zapisz();
        }

        class DalekaIGłębokaKlasa
        {
            public void Metoda()
            {
                Log.Instancja.Dodaj("DalekaKlasa.Metoda");
            }
        }
    }
}
